<?php

namespace EuKit\Base;

use EuKit\Base\Interfaces\ViewModel;
use Infomaker\Everyware\Base\Menus;

/**
 * Class BasePageTemplate
 * @package EuKit\Base
 */
class BasePageTemplate implements ViewModel
{
    /**
     * @var array
     */
    protected $viewData = [];

    public function __construct()
    {
        $this->initViewData();
    }

    public function getViewData(): array
    {
        return $this->viewData;
    }

    /**
     * Initiates generic view data with menu data
     */
    protected function initViewData(): void
    {
        $this->mergeViewData(['topmenu' => $this->getMenuItems('top-menu')]);
        $this->mergeViewData(['menu' => $this->getMenuItems('main-menu')]);
    }

    protected function getMenuItems(string $menuName)
    {
        $menu = Menus::getFromLocation($menuName);
        return $menu ? $menu->items(true) : [];
    }

    /**
     * Replaces view data values with values from provided array
     */
    protected function mergeViewData(array $arr): void
    {
        $this->viewData = array_replace($this->viewData, $arr);
    }
}
